HDU 3582 BFS

点击打开链接

题意:迷宫从起点走到终点,问能否走到,K是钥匙,L是门,每个钥匙只能用一次然后*是障碍,点是空地

思路:这题开始写到AC竟然错了30+,20+的MLE,因为自己写SB了,先说说我MLE的经验把,对于一把钥匙来说,我只能捡一次但是对于不同状态来的是要区分的,之前我写的就是不管什么状态来的我都要把钥匙捡起来,MLE,发现后又WA了几发,我们在队列里的状态要把哪个钥匙捡起来做个标记,防止上面说的错误,然后对于每个门来说,则可以用状态压缩来搞定,这题过的真心爽,刚开始MLE的我都要怀疑人生了,大神们怎么可以只用100多K就过了,我还在MLE,还好放了几天后脑袋清醒了很多,终于过了

#include <queue>
#include <stdio.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
const int inf=0x3f3f3f3f;
const ll INF=0x3f3f3f3f3f3f3f3fll;
const int maxn=15;
int sx,sy,ex,ey,n,m,cnt;
int dir[4][2]={{0,1},{0,-1},{1,0},{-1,0}};
bool vis[maxn][maxn][1030][100];
char str[maxn][maxn];
struct edge{
    int x,y,step,flag,ss;
    char str1[maxn][maxn];
};
struct snake{
    int x,y;
}sna[maxn*maxn];
int bfs(){
    queue<edge>que;
    edge c,ne;
    memset(vis,0,sizeof(vis));
    str[sx][sy]='.';str[ex][ey]='.';
    c.x=sx,c.y=sy,c.step=0;c.flag=0;c.ss=0;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            c.str1[i][j]='.';
        }
    }
    vis[c.x][c.y][0][0]=1;
    que.push(c);
    while(!que.empty()){
        c=que.front();que.pop();
        if(c.flag<c.step) continue;
        if(c.x==ex&&c.y==ey) return 1;
        for(int i=0;i<4;i++){
            int xx=c.x+dir[i][0];
            int yy=c.y+dir[i][1];
            if(xx<0||xx>n-1||yy<0||yy>m-1||str[xx][yy]=='*') continue;
            if(vis[xx][yy][c.ss][c.flag]) continue;
            ne.x=xx;ne.y=yy;ne.step=c.step;ne.flag=c.flag;ne.ss=c.ss;
            for(int ll=0;ll<n;ll++) strcpy(ne.str1[ll],c.str1[ll]);
            if(str[xx][yy]=='L'){
                for(int i=0;i<cnt;i++){
                    if(xx==sna[i].x&&yy==sna[i].y){
                        if((ne.ss>>i)&1){
                            ne.step=c.step;
                        }else{
                            ne.step=c.step+1;
                            ne.ss+=(1<<i);
                        }
                        break;
                    }
                }
            }
            if(str[xx][yy]=='K'){
                if(c.str1[xx][yy]=='.') ne.flag=c.flag+1;
                ne.str1[xx][yy]='*';
            }
            vis[ne.x][ne.y][ne.ss][ne.flag]=1;
            que.push(ne);
        }
    }
    return -1;
}
int main(){
    int T,cas=1;
    scanf("%d",&T);
    while(T--){
        scanf("%d",&n);
        m=n;cnt=0;
        for(int i=0;i<n;i++) scanf("%s",str[i]);
        for(int i=0;i<n;i++){
            for(int j=0;j<m;j++){
                if(str[i][j]=='S') sx=i,sy=j;
                if(str[i][j]=='E') ex=i,ey=j;
                if(str[i][j]=='L'){
                    sna[cnt].x=i;
                    sna[cnt++].y=j;
                }
            }
        }
        int ans=bfs();
        if(ans==-1) printf("Case %d: No\n",cas++);
        else printf("Case %d: Yes\n",cas++);
    }
    return 0;
}
时间: 2024-10-13 20:07:30

HDU 3582 BFS的相关文章

hdu 1175 bfs 转弯题

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1175 和之前的1728类似.就是判断转弯数,建立一个用于记录转弯数的数组.. 还有就是对于特殊情况要进行考虑,比如起点与终点相同的情况,对于本题来说是不可以消去的应该输出NO.还有就是起点或终点是零这也是不行的,因为0代表没有棋子... 还有在判断能不能走的时候要小心,对于判断条件一定要小心,不要图赶快写.. 错误的地方都写在注释中了.. 代码: // hdu 1175 bfs 转弯数 //1.起点

Saving Princess claire_(hdu 4308 bfs模板题)

http://acm.hdu.edu.cn/showproblem.php?pid=4308 Saving Princess claire_ Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2305    Accepted Submission(s): 822 Problem Description Princess claire_ wa

HDU 1072 bfs

Nightmare Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 7083    Accepted Submission(s): 3409 Problem Description Ignatius had a nightmare last night. He found himself in a labyrinth with a tim

hdu 1252 BFS

1 /* 2 题意:给出一个m*m矩阵表示的完全图,且每个点都有自环,每条边都有一种颜色:有三个玩家ABC的三张纸片分别初始在 3 某三个位置(可以重叠),纸片可以沿着边走一步,可以走的路径的规则为:若A要走到某个点i,则A-i的颜色要和B-C的颜 4 色相同:问最少要走多少步.(题意太难懂了,看了别人的说明才弄懂了题意) 5 6 题解:BFS 7 首先初步分析题意似乎很难用图论来解决,那么就是搜索/DP/数据结构,然后从搜索方面去思考的话,就是要找状态,然 8 后初步列出所有信息,三个点得位置

hdu 4707 bfs

bfs基础算法水题 #include<iostream> #include<cstdio> #include<cstring> #include<algorithm> #include<string> #include<vector> #include<queue> using namespace std; const int Max = 1e5+50; int dist[Max]; vector<int> t

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

hdu 1226 BFS + bfs记录路径

http://acm.hdu.edu.cn/showproblem.php?pid=1226 为了省空间,可以用vis数组初始化的时候初始化为-1, 发现一个BFS容易错的地方 开始一直WA在这里:就是我int tp=q.front();之后马上q.pop():了,然后才去判断是不是符合条件以break,这样就不能根据q.empty()==1认为没有找到ans 因为这里WA了 其实也可以vis[0] == -1来判断 比较不理解的是 当n==0的时候 %n==0的时候怎么处理 //#pragma

hdu 5025 BFS + 优化 广东区域赛网赛

http://acm.hdu.edu.cn/showproblem.php?pid=5025 TLE了好几次 写的时候,问题在于, 1.钥匙怎么处理 参考了他人的写法,vis[key_num][i][j],相当于将图多维化,这样就可以判重了,否则只是按照普通的BFS,钥匙数不同的时候,可以重复,这个代码难易表达出来 另外此处一个很好的优化,当cost_now<cost[key_now][x_now][y_now]的时候,才q.push(Node)  这个剪枝很好啊 2.蛇怎么处理 没蛇的话,第一

hdu 1430 (BFS 康托展开 或 map )

第一眼看到这题就直接BFS爆搜,第一发爆了内存,傻逼了忘标记了,然后就改,咋标记呢. 然后想到用map函数,就8!个不同的排列,换成字符串用map标记.然后又交一发果断超时,伤心,最恨超时,还不如来个wa算了. 然后卡着了,后来上网上搜了,要用康托展开,康托展开是什么鬼?然后学习了一下,就是个映射,感觉和map差不多. http://blog.csdn.net/zhongkeli/article/details/6966805这个学习一下康托展开. 其实本题的关键不是康托展开,而是置换. 以12